{********************************************************}
{                                                        }
{                 Zeos Database Objects                  }
{               Interbase property editors               }
{                                                        }
{       Copyright (c) 1999-2001 Sergey Seroukhov         }
{                                                        }
{********************************************************}

unit ZIbSqlProp;

interface

uses Classes, DsgnIntf, ZProperty;

{$INCLUDE ..\Zeos.inc}

type
  { Property editor for TIbSqlTable }
  TZIbSqlTableNameProperty = class(TDbPropertyEditor)
    procedure GetValueList(Values: TStringList); override;
  end;

implementation

uses SysUtils, ZDirIbSql, ZIbSqlCon, ZIbSqlQuery;

{*********** TZIbSqlTableNameProperty implementation ***********}

procedure TZIbSqlTableNameProperty.GetValueList(Values: TStringList);
var
  Connect: TDirIbSqlConnect;
  Transact: TDirIbSqlTransact;
  Query: TDirIbSqlQuery;
begin
  with GetComponent(0) as TZIbSqlTable do
  begin
    if not Assigned(Database) then Exit;

    if (FHost = Database.Host) and (FDatabase = Database.Database)
      and FRead and Assigned(FList) then
    begin
      Values.Assign(FList);
      Exit;
    end;
  end;

  Connect  := TDirIbSqlConnect.Create;
  Transact := TDirIbSqlTransact.Create(Connect);
  Query    := TDirIbSqlQuery.Create(Connect, Transact);
  try
    with GetComponent(0) as TZIbSqlTable do
    begin
      if Assigned(Database) then
      begin
        Connect.HostName := Database.Host;
        Connect.Database := Database.Database;
        Connect.Login    := Database.Login;
        Connect.Passwd   := Database.Password;
      end;
      Connect.Connect;
      Transact.Open;
    end;
    if Transact.Active then
    begin
      Query.ShowTables('');
      if Query.Active then
      begin
        if not Assigned(FList) then
          FList := TStringList.Create;
        FList.Clear;
        while not Query.Eof do
        begin
          FList.Add(Trim(Query.Field(1)));
          Query.Next;
        end;
        Values.Assign(FList);
        FRead := True;
        with GetComponent(0) as TZIbSqlTable do
        begin
          FHost := Database.Host;
          FDatabase := Database.Database;
        end;
      end;
    end;
  finally
    Query.Free;
    Transact.Free;
    Connect.Free;
  end;
end;

end.
